'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _has2 = require('lodash/has');

var _has3 = _interopRequireDefault(_has2);

var _get2 = require('lodash/get');

var _get3 = _interopRequireDefault(_get2);

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _reactAce = require('react-ace');

var _reactAce2 = _interopRequireDefault(_reactAce);

var _PatchEvent = require('@sanity/form-builder/PatchEvent');

var _PatchEvent2 = _interopRequireDefault(_PatchEvent);

var _default = require('part:@sanity/components/formfields/default');

var _default2 = _interopRequireDefault(_default);

var _default3 = require('part:@sanity/components/fieldsets/default');

var _default4 = _interopRequireDefault(_default3);

var _default5 = require('part:@sanity/components/selects/default');

var _default6 = _interopRequireDefault(_default5);

var _Fieldset = require('./Fieldset.css');

var _Fieldset2 = _interopRequireDefault(_Fieldset);

var _createHighlightMarkers = require('./createHighlightMarkers');

var _createHighlightMarkers2 = _interopRequireDefault(_createHighlightMarkers);

var _config = require('./config');

require('brace/mode/batchfile');

require('brace/mode/css');

require('brace/mode/html');

require('brace/mode/javascript');

require('brace/mode/json');

require('brace/mode/jsx');

require('brace/mode/latex');

require('brace/mode/markdown');

require('brace/mode/matlab');

require('brace/mode/php');

require('brace/mode/sh');

require('brace/mode/text');

require('brace/theme/github');

require('brace/theme/monokai');

require('brace/theme/terminal');

require('brace/theme/tomorrow');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function compareNumbers(numA, numB) {
  return numA - numB;
}

var CodeInput = function (_PureComponent) {
  _inherits(CodeInput, _PureComponent);

  function CodeInput() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, CodeInput);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = CodeInput.__proto__ || Object.getPrototypeOf(CodeInput)).call.apply(_ref, [this].concat(args))), _this), _this.state = {
      hasFocus: false
    }, _this.handleCodeChange = function (code) {
      var _this$props = _this.props,
          type = _this$props.type,
          onChange = _this$props.onChange;

      var path = ['code'];
      var fixedLanguage = (0, _get3.default)(type, 'options.language');

      onChange(_PatchEvent2.default.from([(0, _PatchEvent.setIfMissing)({ _type: type.name, language: fixedLanguage }), code ? (0, _PatchEvent.set)(code, path) : (0, _PatchEvent.unset)(path)]));
    }, _this.handleToggleSelectLine = function (lineNumber) {
      var _this$props2 = _this.props,
          type = _this$props2.type,
          onChange = _this$props2.onChange,
          value = _this$props2.value;

      var path = ['highlightedLines'];
      var highlightedLines = value && value.highlightedLines || [];

      var position = highlightedLines.indexOf(lineNumber);
      var patches = [(0, _PatchEvent.setIfMissing)({ _type: type.name }), (0, _PatchEvent.setIfMissing)([], ['highlightedLines'])];
      var addLine = position === -1;

      if (addLine) {
        // New element, figure out where to add it so it sorts correctly
        var sorted = highlightedLines.concat(lineNumber).sort(compareNumbers);
        position = sorted.indexOf(lineNumber);
        patches.push((0, _PatchEvent.insert)([lineNumber], 'before', path.concat(position === sorted.length - 1 ? -1 : position)));
      } else if (highlightedLines.length === 1) {
        // Last element removed, unset whole path
        patches.push((0, _PatchEvent.unset)(path));

        // Temporary workaround for bug in react-ace
        // (https://github.com/securingsincity/react-ace/issues/229)
        var editor = _this.editor

        // Remove all markers from editor
        ;[true, false].forEach(function (inFront) {
          var currentMarkers = editor.getSession().getMarkers(inFront);
          Object.keys(currentMarkers).forEach(function (marker) {
            editor.getSession().removeMarker(currentMarkers[marker].id);
          });
        });
      } else {
        // Removed, but not the last element, remove single item
        patches.push((0, _PatchEvent.unset)(path.concat(position)));
      }

      onChange(_PatchEvent2.default.from(patches));
    }, _this.handleGutterMouseDown = function (event) {
      var target = event.domEvent.target;
      if (target.classList.contains('ace_gutter-cell')) {
        var row = event.getDocumentPosition().row;
        _this.handleToggleSelectLine(row + 1); // Ace starts at row 0
      }
    }, _this.handleEditorLoad = function (editor) {
      _this.editor = editor;
      _this.editor.focus();
      _this.editor.on('guttermousedown', _this.handleGutterMouseDown);
    }, _this.handleLanguageChange = function (item) {
      var _this$props3 = _this.props,
          type = _this$props3.type,
          onChange = _this$props3.onChange;

      var path = ['language'];
      onChange(_PatchEvent2.default.from([(0, _PatchEvent.setIfMissing)({ _type: type.name }), item ? (0, _PatchEvent.set)(item.value, path) : (0, _PatchEvent.unset)(path)]));
    }, _this.renderEditor = function () {
      var _this$props4 = _this.props,
          value = _this$props4.value,
          type = _this$props4.type;

      var fixedLanguage = (0, _get3.default)(type, 'options.language');
      return _react2.default.createElement(_reactAce2.default, {
        mode: value && value.language || fixedLanguage || 'text',
        theme: _this.getTheme(),
        width: '100%',
        onChange: _this.handleCodeChange,
        name: _this._inputId + '__aceEditor',
        value: value && value.code || '',
        markers: value && value.highlightedLines ? (0, _createHighlightMarkers2.default)(value.highlightedLines) : null,
        onLoad: _this.handleEditorLoad,
        tabSize: 2,
        setOptions: _config.ACE_SET_OPTIONS,
        editorProps: _config.ACE_EDITOR_PROPS
      });
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(CodeInput, [{
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      this.editor.removeListener('guttermousedown', this.handleGutterMouseDown);
    }
  }, {
    key: 'getLanguageAlternatives',
    value: function getLanguageAlternatives() {
      return (0, _get3.default)(this.props.type, 'options.languageAlternatives') || _config.SUPPORTED_LANGUAGES;
    }
  }, {
    key: 'getTheme',
    value: function getTheme() {
      var preferredTheme = (0, _get3.default)(this.props.type, 'options.theme');
      return preferredTheme && _config.SUPPORTED_THEMES.find(function (theme) {
        return theme === preferredTheme;
      }) ? preferredTheme : _config.DEFAULT_THEME;
    }
  }, {
    key: 'render',
    value: function render() {
      var _props = this.props,
          value = _props.value,
          type = _props.type,
          level = _props.level;

      var languages = this.getLanguageAlternatives();

      if ((0, _has3.default)(type, 'options.language')) {
        return _react2.default.createElement(
          _default4.default,
          { styles: _Fieldset2.default, legend: type.title, description: type.description },
          this.renderEditor()
        );
      }

      var selectedLanguage = value && value.language ? this.getLanguageAlternatives().find(function (item) {
        return item.value === value.language;
      }) : undefined;

      if (!selectedLanguage) {
        languages.unshift({ title: 'Select language' });
      }
      var languageField = type.fields.find(function (field) {
        return field.name === 'language';
      });

      return _react2.default.createElement(
        _default4.default,
        { legend: type.title, description: type.description },
        _react2.default.createElement(
          _default2.default,
          { level: level + 1, label: languageField.type.title },
          _react2.default.createElement(_default6.default, {
            onChange: this.handleLanguageChange,
            value: selectedLanguage,
            items: languages
          })
        ),
        _react2.default.createElement(
          _default2.default,
          { label: type.title, level: level + 1 },
          this.renderEditor()
        )
      );
    }
  }]);

  return CodeInput;
}(_react.PureComponent);

CodeInput.propTypes = {
  level: _propTypes2.default.number.isRequired,
  value: _propTypes2.default.shape({
    _type: _propTypes2.default.string,
    code: _propTypes2.default.string,
    language: _propTypes2.default.string,
    highlightedLines: _propTypes2.default.array
  }),
  type: _propTypes2.default.shape({
    name: _propTypes2.default.string,
    title: _propTypes2.default.string,
    description: _propTypes2.default.string,
    fields: _propTypes2.default.arrayOf(_propTypes2.default.shape({
      name: _propTypes2.default.string.isRequired
    }))
  }).isRequired,
  onChange: _propTypes2.default.func
};
CodeInput.defaultProps = {
  onChange: function onChange() {}
};
exports.default = CodeInput;